#pragma once
#include "FFGL.h"
#include "ParamBase.h"

namespace ffgl
{

class ParamFloat : public ParamBase
{
protected:
	float value;
	float defaultValue;

public:
	ParamFloat( const std::string& name, float defaultValue = 0.0f );
	ParamFloat( const std::string& name, const std::string& uniformName, float defaultValue = 0.0f );
	ParamFloat( const std::string& name, ParameterType type, float defaultValue = 0.0f );
	ParamFloat( const std::string& name, ParameterType type, const std::string& uniformName, float defaultValue = 0.0f );

	~ParamFloat();

	void Reset() override;
	const std::string& GetDisplay() const override;
	FFMixed GetMixedDefault() const override;
	FFMixed GetMixedValue() const override;
	FFResult SetMixedValue( FFMixed mixed ) override;

	virtual float GetFloatDefault() const;
	virtual float GetFloatValue() const;
	virtual void SetFloatValue( float floatValue );
};

}//End namespace ffgl
